
// MatrixGridDoc.cpp : implementation of the CMatrixGridDoc class
//

#include "stdafx.h"
// SHARED_HANDLERS can be defined in an ATL project implementing preview, thumbnail
// and search filter handlers and allows sharing of document code with that project.
#ifndef SHARED_HANDLERS
#include "MatrixGrid.h"
#endif

#include "MatrixGridDoc.h"
#include "Cell.h"

#include <propkey.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CMatrixGridDoc

IMPLEMENT_DYNCREATE(CMatrixGridDoc, CDocument)

BEGIN_MESSAGE_MAP(CMatrixGridDoc, CDocument)
END_MESSAGE_MAP()


// CMatrixGridDoc construction/destruction

CMatrixGridDoc::CMatrixGridDoc()
{
	m_edit = NULL;
	m_iColoums = COL;
	m_iHeight = HEIGHT;
	m_iRow = ROW;
	m_iWidth = WIDTH;
	m_iXoffset = XOFFSET;
	m_iYoffset = YOFFSET;

}

CMatrixGridDoc::~CMatrixGridDoc()
{
}

BOOL CMatrixGridDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}




// CMatrixGridDoc serialization

void CMatrixGridDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		for (int iRowIndex = 0; iRowIndex<m_iRow; iRowIndex++)
			for (int iColIndex = 0; iColIndex<m_iColoums; iColIndex++)
			{
				ar << m_arrCellArray[iRowIndex][iColIndex].m_iColor;
				ar << m_arrCellArray[iRowIndex][iColIndex].m_cColor;
				ar << m_arrCellArray[iRowIndex][iColIndex].m_strText;
			}
		ar << m_iColoums;
		ar << m_iRow;
		ar << m_iWidth;
		ar << m_iHeight;

	}
	else
	{
		for (int iRowIndex = 0; iRowIndex<m_iRow; iRowIndex++)
			for (int iColIndex = 0; iColIndex<m_iColoums; iColIndex++)
			{
				ar >> m_arrCellArray[iRowIndex][iColIndex].m_iColor;
				ar >> m_arrCellArray[iRowIndex][iColIndex].m_cColor;
				ar >> m_arrCellArray[iRowIndex][iColIndex].m_strText;

			}
		ar >> m_iColoums;
		ar >> m_iRow;
		ar >> m_iWidth;
		ar >> m_iHeight;

	}
}

#ifdef SHARED_HANDLERS

// Support for thumbnails
void CMatrixGridDoc::OnDrawThumbnail(CDC& dc, LPRECT lprcBounds)
{
	// Modify this code to draw the document's data
	dc.FillSolidRect(lprcBounds, RGB(255, 255, 255));

	CString strText = _T("TODO: implement thumbnail drawing here");
	LOGFONT lf;

	CFont* pDefaultGUIFont = CFont::FromHandle((HFONT) GetStockObject(DEFAULT_GUI_FONT));
	pDefaultGUIFont->GetLogFont(&lf);
	lf.lfHeight = 36;

	CFont fontDraw;
	fontDraw.CreateFontIndirect(&lf);

	CFont* pOldFont = dc.SelectObject(&fontDraw);
	dc.DrawText(strText, lprcBounds, DT_CENTER | DT_WORDBREAK);
	dc.SelectObject(pOldFont);
}

// Support for Search Handlers
void CMatrixGridDoc::InitializeSearchContent()
{
	CString strSearchContent;
	// Set search contents from document's data. 
	// The content parts should be separated by ";"

	// For example:  strSearchContent = _T("point;rectangle;circle;ole object;");
	SetSearchContent(strSearchContent);
}

void CMatrixGridDoc::SetSearchContent(const CString& value)
{
	if (value.IsEmpty())
	{
		RemoveChunk(PKEY_Search_Contents.fmtid, PKEY_Search_Contents.pid);
	}
	else
	{
		CMFCFilterChunkValueImpl *pChunk = NULL;
		ATLTRY(pChunk = new CMFCFilterChunkValueImpl);
		if (pChunk != NULL)
		{
			pChunk->SetTextValue(PKEY_Search_Contents, value, CHUNK_TEXT);
			SetChunkValue(pChunk);
		}
	}
}

#endif // SHARED_HANDLERS

// CMatrixGridDoc diagnostics

#ifdef _DEBUG
void CMatrixGridDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CMatrixGridDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG


// CMatrixGridDoc commands
