
// MatrixGridView.cpp : implementation of the CMatrixGridView class
//

#include "stdafx.h"
// SHARED_HANDLERS can be defined in an ATL project implementing preview, thumbnail
// and search filter handlers and allows sharing of document code with that project.
#ifndef SHARED_HANDLERS
#include "MatrixGrid.h"
#endif

#include "MatrixGridDoc.h"
#include "MatrixGridView.h"
#include "Cell.h"
#include "resource.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMatrixGridView

IMPLEMENT_DYNCREATE(CMatrixGridView, CScrollView)

BEGIN_MESSAGE_MAP(CMatrixGridView, CScrollView)
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, &CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, &CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, &CScrollView::OnFilePrintPreview)
	ON_COMMAND(ID_ZOOM_25, &CMatrixGridView::OnZoom25)
	ON_COMMAND(ID_ZOOM_50, &CMatrixGridView::OnZoom50)
	ON_COMMAND(ID_ZOOM_100, &CMatrixGridView::OnZoom100)
	ON_COMMAND(ID_ZOOM_200, &CMatrixGridView::OnZoom200)
	ON_COMMAND(ID_EDIT_UNDO, &CMatrixGridView::OnEditUndo)
	ON_COMMAND(ID_EDIT_CUT, &CMatrixGridView::OnEditCut)
	ON_COMMAND(ID_EDIT_COPY, &CMatrixGridView::OnEditCopy)
	ON_COMMAND(ID_EDIT_PASTE, &CMatrixGridView::OnEditPaste)
	ON_WM_LBUTTONDOWN()
	ON_COMMAND(ID_POPUP_COLOR, &CMatrixGridView::OnPopupColor)
	ON_WM_CONTEXTMENU()
	ON_WM_LBUTTONDBLCLK()
END_MESSAGE_MAP()

// CMatrixGridView construction/destruction

CMatrixGridView::CMatrixGridView()
{
	m_iRowIndex = 1;
	m_iColIndex = 1;

}

CMatrixGridView::~CMatrixGridView()
{
}

BOOL CMatrixGridView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CScrollView::PreCreateWindow(cs);
}

// CMatrixGridView drawing

void CMatrixGridView::OnDraw(CDC* pDC)
{
	CMatrixGridDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	InitializeCell();
	FillColor(pDC);
	SetScrollPosition();
	DrawGrid(pDC);

	// TODO: add draw code for native data here
}

void CMatrixGridView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();

	CSize sizeTotal;
	// TODO: calculate the total size of this view
	sizeTotal.cx = sizeTotal.cy = 100;
	SetScrollSizes(MM_TEXT, sizeTotal);
}


// CMatrixGridView printing

BOOL CMatrixGridView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CMatrixGridView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CMatrixGridView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}


// CMatrixGridView diagnostics

#ifdef _DEBUG
void CMatrixGridView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CMatrixGridView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CMatrixGridDoc* CMatrixGridView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMatrixGridDoc)));
	return (CMatrixGridDoc*)m_pDocument;
}
#endif //_DEBUG


// CMatrixGridView message handlers


void CMatrixGridView::DrawGrid(CDC *pDC)
{
	CMatrixGridDoc *pDoc = GetDocument();
	int iIndex;
	for (iIndex = 0; iIndex <= pDoc->m_iColoums; iIndex++)
	{
		pDC->MoveTo(pDoc->m_iXoffset + (iIndex*pDoc->m_iWidth), pDoc->m_iYoffset);
		pDC->LineTo(pDoc->m_iXoffset + (iIndex*pDoc->m_iWidth), pDoc->m_iYoffset + (pDoc->m_iHeight*pDoc->m_iRow));
	}
	for (iIndex = 0; iIndex <= pDoc->m_iRow; iIndex++)
	{
		pDC->MoveTo(pDoc->m_iXoffset, pDoc->m_iYoffset + (iIndex*pDoc->m_iHeight));
		pDC->LineTo(pDoc->m_iXoffset + (pDoc->m_iWidth*pDoc->m_iColoums), pDoc->m_iYoffset + (iIndex*pDoc->m_iHeight));
	}
}


void CMatrixGridView::OnZoom25()
{
	CMatrixGridDoc *pDoc = GetDocument();
	pDoc->m_iHeight = HEIGHT*.25;
	pDoc->m_iWidth = WIDTH*.25;
	SetScrollPosition();
	Invalidate();
}


void CMatrixGridView::OnZoom50()
{
	CMatrixGridDoc *pDoc = GetDocument();
	pDoc->m_iHeight = HEIGHT*.50;
	pDoc->m_iWidth = WIDTH*.50;
	SetScrollPosition();
	Invalidate();
}


void CMatrixGridView::OnZoom100()
{
	CMatrixGridDoc *pDoc = GetDocument();
	pDoc->m_iHeight = HEIGHT*1;
	pDoc->m_iWidth = WIDTH*1;
	SetScrollPosition();
	Invalidate();
}


void CMatrixGridView::OnZoom200()
{
	CMatrixGridDoc *pDoc = GetDocument();
	pDoc->m_iHeight = HEIGHT*2;
	pDoc->m_iWidth = WIDTH*2;
	SetScrollPosition();
	Invalidate();
}


void CMatrixGridView::OnEditUndo()
{
	AfxMessageBox(_T("Add code for undo operation here"));
}


void CMatrixGridView::OnEditCut()
{
	AfxMessageBox(_T("Add code for cut operation here"));
}


void CMatrixGridView::OnEditCopy()
{
	AfxMessageBox(_T("Add code for copy operation here"));
}


void CMatrixGridView::OnEditPaste()
{
	AfxMessageBox(_T("Add code for paste operation here"));
}


void CMatrixGridView::SetScrollPosition()
{
	CMatrixGridDoc *pDoc = GetDocument();
	int iHorizontalPosition = pDoc->m_iXoffset + pDoc->m_iColoums*pDoc->m_iWidth + 100;
	int iVerticalPosition = pDoc->m_iYoffset + pDoc->m_iRow*pDoc->m_iHeight + 100;
	SetScrollSizes(MM_TEXT, CSize(iHorizontalPosition, iVerticalPosition));
}


void CMatrixGridView::InitializeCell()
{
	CMatrixGridDoc *pDoc = GetDocument();
	for (int iRowIndex = 0; iRowIndex<pDoc->m_iRow; iRowIndex++)
	{
		for (int iColIndex = 0; iColIndex<pDoc->m_iColoums; iColIndex++)
		{
			pDoc->m_arrCellArray[iRowIndex][iColIndex].m_Rect.SetRect(0, 0, pDoc->m_iWidth, pDoc->m_iHeight);
			pDoc->m_arrCellArray[iRowIndex][iColIndex].m_Rect.OffsetRect(pDoc->m_iXoffset + (pDoc->m_iWidth*iColIndex), pDoc->m_iYoffset + (pDoc->m_iHeight*iRowIndex));
		}
	}
}


void CMatrixGridView::FillColor(CDC *pDC)
{
	CMatrixGridDoc *pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	CBrush WhiteBrush(RGB(255, 255, 255));
	CBrush RedBrush(RGB(255, 0, 0));
	CBrush BlueBrush(RGB(0, 0, 255));
	CBrush GreenBrush(RGB(0, 255, 0));
	for (int iRowIndex = 0; iRowIndex<pDoc->m_iRow; iRowIndex++)
		for (int iColIndex = 0; iColIndex<pDoc->m_iColoums; iColIndex++)
		{
			switch (pDoc->m_arrCellArray[iRowIndex][iColIndex].m_iColor)
			{
			case WHITE:
			{
				pDC->FillRect(pDoc->m_arrCellArray[iRowIndex][iColIndex].m_Rect, &WhiteBrush);
				break;
			}
			case RED:
			{
				pDC->FillRect(pDoc->m_arrCellArray[iRowIndex][iColIndex].m_Rect, &RedBrush);
				break;
			}

			case GREEN:
			{
				pDC->FillRect(pDoc->m_arrCellArray[iRowIndex][iColIndex].m_Rect, &GreenBrush);
				break;
			}
			case BLUE:
			{
				pDC->FillRect(pDoc->m_arrCellArray[iRowIndex][iColIndex].m_Rect, &BlueBrush);
				break;
			}
			case CUSTOM:
			{
				CBrush CustomBrush(pDoc->m_arrCellArray[iRowIndex][iColIndex].m_cColor);
				pDC->FillRect(pDoc->m_arrCellArray[iRowIndex][iColIndex].m_Rect, &CustomBrush);
				break;
			}
			}
			pDC->DrawText(pDoc->m_arrCellArray[iRowIndex][iColIndex].m_strText, pDoc->m_arrCellArray[iRowIndex][iColIndex].m_Rect, DT_LEFT);
		}
}


void CMatrixGridView::OnLButtonDown(UINT nFlags, CPoint point)
{
	CMatrixGridDoc *pDoc = GetDocument();
	CPoint point1;
	DeleteWindow();
	point1 = GetScrollPosition();
	point += point1;
	for (int iRowIndex = 0; iRowIndex<pDoc->m_iRow; iRowIndex++)
	{
		for (int iColIndex = 0; iColIndex<pDoc->m_iColoums; iColIndex++)
		{
			if (pDoc->m_arrCellArray[iRowIndex][iColIndex].m_Rect.PtInRect(point))
			{
				m_iColIndex = iColIndex;
				m_iRowIndex = iRowIndex;

				if (pDoc->m_arrCellArray[iRowIndex][iColIndex].m_iColor>BLUE)
				{
					pDoc->m_arrCellArray[iRowIndex][iColIndex].m_iColor = WHITE;
				}
				else
				{
					pDoc->m_arrCellArray[iRowIndex][iColIndex].m_iColor++;
				}
			}
		}
	}
	Invalidate();

	CScrollView::OnLButtonDown(nFlags, point);
}


void CMatrixGridView::OnPopupColor()
{
	CColorDialog ColorDialog;
	CMatrixGridDoc *pDoc = GetDocument();

	if (ColorDialog.DoModal() == IDOK)
	{
		pDoc->m_cColor = ColorDialog.GetColor();

		pDoc->m_arrCellArray[m_iRowIndex][m_iColIndex].m_cColor = pDoc->m_cColor;
		pDoc->m_arrCellArray[m_iRowIndex][m_iColIndex].m_iColor = CUSTOM;

	}
	Invalidate();
}


void CMatrixGridView::OnContextMenu(CWnd* /*pWnd*/, CPoint point)
{
	CMatrixGridDoc *pDoc = GetDocument();

	for (int iRowIndex = 0; iRowIndex<pDoc->m_iRow; iRowIndex++)
	{
		for (int iColIndex = 0; iColIndex<pDoc->m_iColoums; iColIndex++)
		{
			if (pDoc->m_arrCellArray[iRowIndex][iColIndex].m_Rect.PtInRect(point))
			{
				CMenu Menu;
				Menu.LoadMenu(IDR_MENU1);
				CMenu *pMenu = Menu.GetSubMenu(0);
				pMenu->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y, this, pDoc->m_arrCellArray[iRowIndex][iColIndex].m_Rect);
			}
		}
	}
}


void CMatrixGridView::OnLButtonDblClk(UINT nFlags, CPoint point)
{
	CMatrixGridDoc *pDoc = GetDocument();
	CPoint point1;
	DeleteWindow();
	point1 = GetScrollPosition();
	for (int iRowIndex = 0; iRowIndex<pDoc->m_iRow; iRowIndex++)
	{
		for (int iColIndex = 0; iColIndex<pDoc->m_iColoums; iColIndex++)
		{
			pDoc->m_arrCellArray[iRowIndex][iColIndex].m_Rect.SetRect(1, 1, pDoc->m_iWidth, pDoc->m_iHeight);
			pDoc->m_arrCellArray[iRowIndex][iColIndex].m_Rect.OffsetRect(pDoc->m_iXoffset + (pDoc->m_iWidth*iColIndex) - point1.x, pDoc->m_iYoffset + (pDoc->m_iHeight*iRowIndex) - point1.y);
			if (pDoc->m_arrCellArray[iRowIndex][iColIndex].m_Rect.PtInRect(point))
			{
				pDoc->m_edit = new CEdit;
				m_iSelRow = iRowIndex;
				m_iSelCol = iColIndex;
				pDoc->m_edit->Create(ES_MULTILINE | WS_CHILD | WS_VISIBLE, pDoc->m_arrCellArray[iRowIndex][iColIndex].m_Rect, this, 1);
				pDoc->m_edit->SetFocus();
				pDoc->m_edit->SetWindowText(pDoc->m_arrCellArray[iRowIndex][iColIndex].m_strText);
			}
		}
	}

	CScrollView::OnLButtonDblClk(nFlags, point);
}


void CMatrixGridView::DeleteWindow()
{
	CMatrixGridDoc *pDoc = GetDocument();
	if (pDoc->m_edit)
	{
		pDoc->m_edit->GetWindowText(pDoc->m_arrCellArray[m_iSelRow][m_iSelCol].m_strText);
		delete(pDoc->m_edit);
		pDoc->m_edit = NULL;
	}
}
