
// MatrixGridView.h : interface of the CMatrixGridView class
//

#pragma once


class CMatrixGridView : public CScrollView
{
protected: // create from serialization only
	CMatrixGridView();
	DECLARE_DYNCREATE(CMatrixGridView)

// Attributes
public:
	int m_iRowIndex;
	int m_iColIndex;
	int m_iSelRow;
	int m_iSelCol;
	CMatrixGridDoc* GetDocument() const;

// Operations
public:

// Overrides
public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:
	virtual void OnInitialUpdate(); // called first time after construct
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);

// Implementation
public:
	virtual ~CMatrixGridView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	DECLARE_MESSAGE_MAP()
public:
	void DrawGrid(CDC *pDC);
	afx_msg void OnZoom25();
	afx_msg void OnZoom50();
	afx_msg void OnZoom100();
	afx_msg void OnZoom200();
	afx_msg void OnEditUndo();
	afx_msg void OnEditCut();
	afx_msg void OnEditCopy();
	afx_msg void OnEditPaste();
	void SetScrollPosition();
	void InitializeCell();
	void FillColor(CDC *pDC);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnPopupColor();
	afx_msg void OnContextMenu(CWnd* /*pWnd*/, CPoint /*point*/);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	void DeleteWindow();
};

#ifndef _DEBUG  // debug version in MatrixGridView.cpp
inline CMatrixGridDoc* CMatrixGridView::GetDocument() const
   { return reinterpret_cast<CMatrixGridDoc*>(m_pDocument); }
#endif

